<?php

class ControllerExtensionModuleCart2cartPasswords extends Controller
{
  public function index()
  {
    $this->language->load('extension/module/cart2cart_passwords');

    $this->document->setTitle($this->language->get('heading_title'));

    $this->load->model('setting/setting');

    if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
      $this->model_setting_setting->editSetting('module_cart2cart_passwords', $this->request->post);

      $this->session->data['success'] = $this->language->get('text_success');

      $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
    }

    if (isset($this->error['warning'])) {
      $data['error_warning'] = $this->error['warning'];
    } else {
      $data['error_warning'] = '';
    }

    $data['breadcrumbs'] = array();

    $data['breadcrumbs'][] = array(
      'text' => $this->language->get('text_home'),
      'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
    );

    $data['breadcrumbs'][] = array(
      'text' => $this->language->get('text_extension'),
      'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
    );

    $data['breadcrumbs'][] = array(
      'text' => $this->language->get('heading_title'),
      'href' => $this->url->link('extension/module/cart2cart_passwords', 'user_token=' . $this->session->data['user_token'], true)
    );

    $data['action'] = $this->url->link('extension/module/cart2cart_passwords', 'user_token=' . $this->session->data['user_token'], true);

    $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);

    if (isset($this->request->post['module_cart2cart_passwords_status'])) {
      $data['module_cart2cart_passwords_status'] = $this->request->post['module_cart2cart_passwords_status'];
    } else {
      $data['module_cart2cart_passwords_status'] = $this->config->get('module_cart2cart_passwords_status');
    }

    $data['header'] = $this->load->controller('common/header');
    $data['column_left'] = $this->load->controller('common/column_left');
    $data['footer'] = $this->load->controller('common/footer');

    $this->response->setOutput($this->load->view('extension/module/cart2cart_passwords', $data));
  }

  protected function validate() {
    if (!$this->user->hasPermission('modify', 'extension/module/cart2cart_passwords')) {
      $this->error['warning'] = $this->language->get('error_permission');
    }

    return !$this->error;
  }

  public function install()
  {
    $this->load->model('setting/event');

    $this->model_setting_event->addEvent('cart2cart_login_before', 'catalog/controller/account/login/before', 'extension/module/cart2cart/activity/loginBefore');
    $this->model_setting_event->addEvent('cart2cart_checkoutlogin_before', 'catalog/controller/checkout/login/save/before', 'extension/module/cart2cart/activity/checkoutLoginBefore');
  }

  public function uninstall()
  {
    $this->load->model('setting/event');

    $this->model_setting_event->deleteEventByCode('cart2cart_login_before');
    $this->model_setting_event->deleteEventByCode('cart2cart_checkoutlogin_before');
  }
}